function ret_val=find_tc(point_of_leak, obs_leakpos, t_end, M, dt, start_leak);

t_w=120/dt;
t_end=t_end/dt;
start_leak=start_leak/dt*60;

win_list=[];
for count_t = t_w:1/dt:t_end
    window=abs(obs_leakpos(count_t-t_w+1:count_t)-point_of_leak);
    win_list=[win_list; mean(window)];
end

less_M=find(win_list<=M);
more_M=find(win_list>M,1,'last');
if ~isempty(less_M) && ~isempty(more_M)
    i=find(less_M>more_M,1,'first');
    if ~isempty(i)
        ret_val=round(round((less_M(i)+119)-start_leak*dt)/6)/10;
    else
        ret_val=-1;
    end
elseif isempty(more_M)
    ret_val=less_M(1);
else
    ret_val=-1;
end