function [wn_hat,q,q_hat,Lambda,w_er]=numerical_boundaries(A,w,w_hat,nu,upper,D0,output_injection,inlet)


%% Separerer ledd tilsvarende negative egenverdier fra positive
[V,D]=eig(A);

if isreal(D)==0
   'ERROR: Komplekse egenverdier'
    [D(1,1) D(2,2) D(3,3) D(4,4)]
end
n=length(w);
I=eye(n);
D2=zeros(n,n);
I2=zeros(n,n);
k=0;
for i=1:n
    if D(i,i)<0
        k=k+1;
    end
end

for i=1:n
    found=0;
   if i==1
       I2(1,:)=I(1,:);
       D2(i,i)=D(1,1);
   else
       for j=1:i-1
          if D(i,i)<D2(j,j)
              I2(j+1:i,:)=I2(j:i-1,:);
              D2(j+1:i,j+1:i)=D2(j:i-1,j:i-1);
              D2(j,j)=D(i,i);
              I2(j,:)=I(i,:);
              j=n-1;
              found=1;
          end
       end
       if found==0
          D2(i,i)=D(i,i);
          I2(i,:)=I(i,:);
       end
   end
end
j=k;
I=I2;
V=V*I';

R=inv(V+eye(n)*0.00000001);
Lambda=I*D*I';
Rum=R(1:j,1:nu);
Rup=R(j+1:n,1:nu);
Rlm=R(1:j,nu+1:n);
Rlp=R(j+1:n,nu+1:n);
wu=w(1:nu);
wl=w(nu+1:n);



if j>(n-j)
    D0=[eye(n-j);zeros(j-(n-j),(n-j))]'*D0;
elseif j==(n-j)
    D0=[eye(n-j)]'*D0;
else
    D0=[eye(j) zeros(j,(n-j)-j)]'*D0;
end
D1=D0';
if upper==1
    if inlet==1
        wn_hat=wu-(Rup-D0*Rum)\(D0*Rlm-Rlp)*(wl-w_hat)*output_injection;
    else
        wn_hat=wu-(D1*Rup-Rum)\(Rlm-D1*Rlp)*(wl-w_hat)*output_injection;
    end
    w_hat=[wn_hat;w_hat];
else
    if inlet==1
        x=-pinv(D0*Rlm-Rlp)*(Rup-D0*Rum);
        wn_hat=wl-(D0*Rlm-Rlp)\(Rup-D0*Rum)*(wu-w_hat)*output_injection;
    else
    wn_hat=wl-(Rlm-D1*Rlp)\(D1*Rup-Rum)*(wu-w_hat)*output_injection;
    end
    w_hat=[w_hat;wn_hat];
end

q=R*w;
q_hat=R*w_hat;
if inlet==1
    vec=[ones(j,1);zeros(n-j,1)];
else
    vec=[zeros(j,1);ones(n-j,1)];
end
q_hat_2=R*(w-w_hat);
q_hat_2=q_hat_2.*vec;
w_er=inv(R)*q_hat_2;
Lambda=[Lambda(1,1) Lambda(2,2) Lambda(3,3) Lambda(4,4)]';
if upper==1
   w_er=w_er(nu+1:n);
else
    w_er=w_er(1:nu);
end
