load mat_files\modeldata_v68_Date-515158_SimLength-35_Leakpos-2250
load mat_files\modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs30_oi0_e0
interval=5
h5=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.9, 0.9]);
subplot(421);
plot(t(1:simlength),m_g_0_mod_store(ii_select_obs),'k-',t(1:simlength),m_g_0_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_G - model','m_G - observer','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(423);
plot(t(1:simlength),m_l_0_mod_store(ii_select_obs),'k-',t(1:simlength),m_l_0_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_L - model','m_L - observer','location','southeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(422);
plot(t(1:simlength),m_g_L_mod_store(ii_select_obs),'k-',t(1:simlength),m_g_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_G - model','m_G - observer','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(424);
plot(t(1:simlength),m_l_L_mod_store(ii_select_obs),'k-',t(1:simlength),m_l_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_L - model','m_L - observer','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(425);
plot(t(1:simlength),w_g_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_g_0_obs_store(1:simlength),'k--');
% plot(t(1:simlength),w_g_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_g_0_obs_store(1:simlength),'k--',t(1:simlength),w_g_obs_0_store_unfiltered(1:simlength),'-r');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_G - model','w_G - observer','location','southeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(426);
plot(t(1:simlength),w_g_L_mod_store(ii_select_obs),'k-',t(1:simlength),w_g_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_G - model','w_G - observer','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(427);
% plot(t(1:simlength),w_l_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_l_0_obs_store(1:simlength),'k--',t(1:simlength),w_l_obs_0_store_unfiltered(1:simlength),'-r');
plot(t(1:simlength),w_l_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_l_0_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_L - model','w_L - observer','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(428);
plot(t(1:simlength),w_l_L_mod_store(ii_select_obs),'k-',t(1:simlength),w_l_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_L - model','w_L - observer','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

load mat_files\modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs32_oi0_e0

subplot(421);
hold on;
plot(t(1:simlength),m_g_0_obs_store(1:simlength),'k-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_G - model','m_G - w/o.i.','m_G - wo/o.i.','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(423);
hold on;
plot(t(1:simlength),m_l_0_obs_store(1:simlength),'k-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_L - model','m_L - w/o.i.','m_L - wo/o.i.','location','southeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(422);
hold on;
plot(t(1:simlength),m_g_L_obs_store(1:simlength),'k-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_G - model','m_G - w/o.i.','m_G - wo/o.i.','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(424);
hold on;
plot(t(1:simlength),m_l_L_obs_store(1:simlength),'k-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_L - model','m_L - w/o.i.','m_L - wo/o.i.','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(425);
hold on;
plot(t(1:simlength),w_g_0_obs_store(1:simlength),'k-.');
% plot(t(1:simlength),w_g_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_g_0_obs_store(1:simlength),'k--',t(1:simlength),w_g_obs_0_store_unfiltered(1:simlength),'-r');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_G - model','w_G - w/o.i.','w_G - wo/o.i.','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(426);
hold on;
plot(t(1:simlength),w_g_L_obs_store(1:simlength),'k-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_G - model','w_G - w/o.i.','w_G - wo/o.i.','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(427);
hold on;
% plot(t(1:simlength),w_l_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_l_0_obs_store(1:simlength),'k--',t(1:simlength),w_l_obs_0_store_unfiltered(1:simlength),'-r');
plot(t(1:simlength),w_l_0_obs_store(1:simlength),'k-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_L - model','w_L - w/o.i.','w_L - wo/o.i.','location','southeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(428);
hold on;
plot(t(1:simlength),w_l_L_obs_store(1:simlength),'k-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_L - model','w_L - w/o.i.','w_L - wo/o.i.','location','southeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;
%%
pos=find(ii_select_obs==(5*60/dt))

if length(pos)>1
    for i=1:8
        for x=2:length(pos);
            subplot(4,2,i)
            line([pos(x)*dt,pos(x)*dt],get(gca,'YLim'),'color',[0.3 0.3 0.3],'LineStyle',':')
        end
    end
end